#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK40x4x40TN2x4x40_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=40, NB=4, KB=40, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=4, ku=40, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + (((lda) << 5)+((lda) << 3));
   const double *stN = B + (((ldb) << 2));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 40
   const int incAm = ((((lda) << 1)) - 40), incAn = -(((lda) << 5)+((lda) << 3));
   #define incBk 40
   const int incBm = -40, incBn = (((ldb) << 2));
   #define incCm 2
   const int incCn = (((ldc) << 2)) - 40;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A, *pA1=pA0+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3;
   do /* M-loop */
   {
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
      ATL_pfl1W(pC3);
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = *pA1;
      rC0_0 = rA0 * rB0;
      rB1 = *pB1;
      rC1_0 = rA1 * rB0;
      rB2 = *pB2;
      rC0_1 = rA0 * rB1;
      rB3 = *pB3;
      rC1_1 = rA1 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC0_3 = rA0 * rB3;
      rC1_3 = rA1 * rB3;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rA1 = pA1[1];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[1];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[1];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[1];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[2];
      rB0 = pB0[2];
      rA1 = pA1[2];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[2];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[2];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[2];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[3];
      rB0 = pB0[3];
      rA1 = pA1[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[3];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[3];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[3];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[4];
      rB0 = pB0[4];
      rA1 = pA1[4];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[4];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[4];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[4];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[5];
      rB0 = pB0[5];
      rA1 = pA1[5];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[5];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[5];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[5];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[6];
      rB0 = pB0[6];
      rA1 = pA1[6];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[6];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[6];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[6];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[7];
      rB0 = pB0[7];
      rA1 = pA1[7];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[7];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[7];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[7];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[8];
      rB0 = pB0[8];
      rA1 = pA1[8];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[8];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[8];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[8];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[9];
      rB0 = pB0[9];
      rA1 = pA1[9];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[9];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[9];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[9];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[10];
      rB0 = pB0[10];
      rA1 = pA1[10];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[10];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[10];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[10];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[11];
      rB0 = pB0[11];
      rA1 = pA1[11];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[11];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[11];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[11];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[12];
      rB0 = pB0[12];
      rA1 = pA1[12];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[12];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[12];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[12];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[13];
      rB0 = pB0[13];
      rA1 = pA1[13];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[13];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[13];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[13];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[14];
      rB0 = pB0[14];
      rA1 = pA1[14];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[14];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[14];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[14];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[15];
      rB0 = pB0[15];
      rA1 = pA1[15];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[15];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[15];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[15];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[16];
      rB0 = pB0[16];
      rA1 = pA1[16];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[16];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[16];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[16];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[17];
      rB0 = pB0[17];
      rA1 = pA1[17];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[17];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[17];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[17];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[18];
      rB0 = pB0[18];
      rA1 = pA1[18];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[18];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[18];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[18];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[19];
      rB0 = pB0[19];
      rA1 = pA1[19];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[19];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[19];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[19];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[20];
      rB0 = pB0[20];
      rA1 = pA1[20];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[20];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[20];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[20];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[21];
      rB0 = pB0[21];
      rA1 = pA1[21];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[21];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[21];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[21];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[22];
      rB0 = pB0[22];
      rA1 = pA1[22];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[22];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[22];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[22];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[23];
      rB0 = pB0[23];
      rA1 = pA1[23];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[23];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[23];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[23];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[24];
      rB0 = pB0[24];
      rA1 = pA1[24];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[24];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[24];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[24];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[25];
      rB0 = pB0[25];
      rA1 = pA1[25];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[25];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[25];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[25];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[26];
      rB0 = pB0[26];
      rA1 = pA1[26];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[26];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[26];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[26];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[27];
      rB0 = pB0[27];
      rA1 = pA1[27];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[27];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[27];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[27];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[28];
      rB0 = pB0[28];
      rA1 = pA1[28];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[28];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[28];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[28];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[29];
      rB0 = pB0[29];
      rA1 = pA1[29];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[29];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[29];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[29];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[30];
      rB0 = pB0[30];
      rA1 = pA1[30];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[30];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[30];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[30];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[31];
      rB0 = pB0[31];
      rA1 = pA1[31];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[31];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[31];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[31];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[32];
      rB0 = pB0[32];
      rA1 = pA1[32];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[32];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[32];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[32];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[33];
      rB0 = pB0[33];
      rA1 = pA1[33];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[33];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[33];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[33];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[34];
      rB0 = pB0[34];
      rA1 = pA1[34];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[34];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[34];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[34];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[35];
      rB0 = pB0[35];
      rA1 = pA1[35];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[35];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[35];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[35];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[36];
      rB0 = pB0[36];
      rA1 = pA1[36];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[36];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[36];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[36];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[37];
      rB0 = pB0[37];
      rA1 = pA1[37];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[37];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[37];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[37];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[38];
      rB0 = pB0[38];
      rA1 = pA1[38];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[38];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[38];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[38];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rA0 = pA0[39];
      rB0 = pB0[39];
      rA1 = pA1[39];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[39];
      rC1_0 += rA1 * rB0;
      rB2 = pB2[39];
      rC0_1 += rA0 * rB1;
      rB3 = pB3[39];
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      pA1 += incAk;
      pB0 += incBk;
      pB1 += incBk;
      pB2 += incBk;
      pB3 += incBk;
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC0_3 *= rB0;
      rC1_0 *= rB0;
      rC1_1 *= rB0;
      rC1_2 *= rB0;
      rC1_3 *= rB0;
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pA1 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
      pB3 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK40x40x40TN0x0x0_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=40, NB=40, KB=40, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=6, ku=40, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((lda) << 5)+((lda) << 3));
   const double *stN = B + (((ldb) << 5)+((ldb) << 2));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 40
   const int incAm = ((((lda) << 1)) - 40), incAn = -(((lda) << 5)+((lda) << 3));
   #define incBk 40
   const int incBm = -40, incBn = (((ldb) << 2)+((ldb) << 1));
   #define incCm 2
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 40;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc);
   const double *pA0=A, *pA1=pA0+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb), *pB5=pB4+(ldb);
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
         ATL_pfl1W(pC5);
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rC0_0 = rA0 * rB0;
         rB1 = *pB1;
         rC1_0 = rA1 * rB0;
         rB2 = *pB2;
         rC0_1 = rA0 * rB1;
         rB3 = *pB3;
         rC1_1 = rA1 * rB1;
         rB4 = *pB4;
         rC0_2 = rA0 * rB2;
         rB5 = *pB5;
         rC1_2 = rA1 * rB2;
         rC0_3 = rA0 * rB3;
         rC1_3 = rA1 * rB3;
         rC0_4 = rA0 * rB4;
         rC1_4 = rA1 * rB4;
         rC0_5 = rA0 * rB5;
         rC1_5 = rA1 * rB5;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA1[1];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[1];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[1];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[1];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[1];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[1];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA1[2];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[2];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[2];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[2];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[2];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[2];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA1[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[3];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[3];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[3];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[3];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[3];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA1[4];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[4];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[4];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[4];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[4];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[4];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rA1 = pA1[5];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[5];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[5];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[5];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[5];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[5];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA1[6];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[6];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[6];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[6];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[6];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[6];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rA1 = pA1[7];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[7];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[7];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[7];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[7];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[7];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA1[8];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[8];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[8];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[8];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[8];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[8];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rA1 = pA1[9];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[9];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[9];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[9];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[9];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[9];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rA1 = pA1[10];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[10];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[10];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[10];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[10];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[10];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rA1 = pA1[11];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[11];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[11];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[11];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[11];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[11];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rA1 = pA1[12];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[12];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[12];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[12];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[12];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[12];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rA1 = pA1[13];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[13];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[13];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[13];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[13];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[13];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rA1 = pA1[14];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[14];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[14];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[14];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[14];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[14];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rA1 = pA1[15];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[15];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[15];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[15];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[15];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[15];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rA1 = pA1[16];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[16];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[16];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[16];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[16];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[16];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rA1 = pA1[17];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[17];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[17];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[17];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[17];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[17];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rA1 = pA1[18];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[18];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[18];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[18];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[18];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[18];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rA1 = pA1[19];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[19];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[19];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[19];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[19];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[19];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rA1 = pA1[20];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[20];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[20];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[20];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[20];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[20];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rA1 = pA1[21];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[21];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[21];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[21];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[21];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[21];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rA1 = pA1[22];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[22];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[22];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[22];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[22];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[22];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rA1 = pA1[23];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[23];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[23];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[23];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[23];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[23];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rA1 = pA1[24];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[24];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[24];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[24];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[24];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[24];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rA1 = pA1[25];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[25];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[25];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[25];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[25];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[25];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rA1 = pA1[26];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[26];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[26];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[26];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[26];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[26];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rA1 = pA1[27];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[27];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[27];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[27];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[27];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[27];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rA1 = pA1[28];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[28];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[28];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[28];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[28];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[28];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rA1 = pA1[29];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[29];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[29];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[29];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[29];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[29];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rA1 = pA1[30];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[30];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[30];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[30];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[30];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[30];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rA1 = pA1[31];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[31];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[31];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[31];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[31];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[31];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rA1 = pA1[32];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[32];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[32];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[32];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[32];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[32];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rA1 = pA1[33];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[33];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[33];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[33];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[33];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[33];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rA1 = pA1[34];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[34];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[34];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[34];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[34];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[34];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rA1 = pA1[35];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[35];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[35];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[35];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[35];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[35];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rA1 = pA1[36];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[36];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[36];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[36];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[36];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[36];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rA1 = pA1[37];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[37];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[37];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[37];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[37];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[37];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rA1 = pA1[38];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[38];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[38];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[38];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[38];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[38];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rA1 = pA1[39];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[39];
         rC1_0 += rA1 * rB0;
         rB2 = pB2[39];
         rC0_1 += rA0 * rB1;
         rB3 = pB3[39];
         rC1_1 += rA1 * rB1;
         rB4 = pB4[39];
         rC0_2 += rA0 * rB2;
         rB5 = pB5[39];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         pA0 += incAk;
         pA1 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         pB4 += incBk;
         pB5 += incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC1_4 *= rB0;
         rC1_5 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         *pC4 = rC0_4;
         pC4[1] = rC1_4;
         *pC5 = rC0_5;
         pC5[1] = rC1_5;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
         pB5 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
   }
   while(pB0 != stN);
   ATL_dJIK40x4x40TN2x4x40_aX_b0(40, 4, 40, alpha, ca, lda, cb + (((ldb) << 5)+((ldb) << 2)), ldb, beta, cc + (((ldc) << 5)+((ldc) << 2)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
