#define DREAL
#include "atlas_misc.h"
void ATL_dupKBmm0_4_0_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm0_8_0_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dpKBmm_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dgpKBmm
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
#include "dmm.h"

void ATL_dpKBmm_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc)
{

   if (K == (((((K) >> 3)) << 3)))
   {
      ATL_dupKBmm0_8_0_b1(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   }
   else if (K == (((((K) >> 2)) << 2)))
   {
      ATL_dupKBmm0_4_0_b1(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   }
   else ATL_dgpKBmm(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
void ATL_dpKBmm_b0
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc);
void ATL_dpKBmm_bX
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc);

void ATL_dpKBmm
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc)
{
   if (M != NB || N != NB)
      ATL_dgpKBmm(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   else if (beta == ATL_rone)
      ATL_dpKBmm_b1(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   else if (beta == ATL_rzero)
      ATL_dpKBmm_b0(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   else
      ATL_dpKBmm_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
