#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x0NT1x1x1_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const double *stM = A + (((Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 2 - (((Kb*lda) << 1)), incAn = -(((Mb) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 2
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=K; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x0NT1x1x8_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)>>3)<<3, kr = K - Kloop - 2;
   const double *stM = A + (((Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 2 - (((Kb*lda) << 1)), incAn = -(((Mb) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 2
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double m0;
   register double rC0_0;
   if (K < 3)
   {
      ATL_zJIK0x0x0NT1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         pA0 += incAk0;
         pB0 += incBk0;
         rA0 = *pA0;
         rB0 = *pB0;

         for (k=Kloop; k; k -= 8) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            break;
         case 4:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            break;
         case 5:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            break;
         case 6:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            break;
         case 7:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk0;
         pB0 += incBk0;
         rC0_0 += m0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_zJIK0x0x0NT2x1x8_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>1)<<1;
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)>>3)<<3, kr = K - Kloop - 2;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 4 - (((Kb*lda) << 1)), incAn = -(((Mb) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 2
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0;
   register double m0, m1;
   register double rC0_0, rC1_0;
   if (K < 3)
   {
      ATL_zJIK0x0x0NT1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            m0 = rA0 * rB0;
            rA1 = pA0[2];
            m1 = rA1 * rB0;
            pA0 += incAk0;
            pB0 += incBk0;
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[2];

            for (k=Kloop; k; k -= 8) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               break;
            case 4:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               break;
            case 5:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               break;
            case 6:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               break;
            case 7:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[2];
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            pA0 += incAk0;
            pB0 += incBk0;
            rC0_0 += m0;
            rC1_0 += m1;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x0x0NT1x1x8_aX_bX(k, N, K, alpha, ca + (((Mb) << 1)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x0NT1x6x8_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=6, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N/6)*6;
   #define Kb K
   const int Kloop = ((K-2)>>3)<<3, kr = K - Kloop - 2;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 2 - (((Kb*lda) << 1)), incAn = -(((Mb) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 12
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5;
   if (K < 3)
   {
      ATL_zJIK0x0x0NT1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            m0 = rA0 * rB0;
            rB1 = pB0[2];
            m1 = rA0 * rB1;
            rB2 = pB0[4];
            m2 = rA0 * rB2;
            rB3 = pB0[6];
            m3 = rA0 * rB3;
            rB4 = pB0[8];
            m4 = rA0 * rB4;
            rB5 = pB0[10];
            m5 = rA0 * rB5;
            pA0 += incAk0;
            pB0 += incBk0;
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[2];

            for (k=Kloop; k; k -= 8) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               break;
            case 4:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               break;
            case 5:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               break;
            case 6:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               break;
            case 7:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[2];
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[4];
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rB3 = pB0[6];
            rC0_2 += m2;
            m2 = rA0 * rB2;
            rB4 = pB0[8];
            rC0_3 += m3;
            m3 = rA0 * rB3;
            rB5 = pB0[10];
            rC0_4 += m4;
            m4 = rA0 * rB4;
            rC0_5 += m5;
            m5 = rA0 * rB5;
            pA0 += incAk0;
            pB0 += incBk0;
            rC0_0 += m0;
            rC0_1 += m1;
            rC0_2 += m2;
            rC0_3 += m3;
            rC0_4 += m4;
            rC0_5 += m5;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            rC0_2 *= rB0;
            rC0_3 *= rB0;
            rC0_4 *= rB0;
            rC0_5 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            *pC5 = rC0_5;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_zJIK0x0x0NT1x1x8_aX_bX(M, k, K, alpha, ca, lda, cb + (((Nb) << 1)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x0x0NT0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=6, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>1)<<1;
   const int Nb = (N/6)*6;
   #define Kb K
   const int Kloop = ((K-1)>>3)<<3, kr = K - Kloop - 1;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 4 - (((Kb*lda) << 1)), incAn = -(((Mb) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 12
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            ATL_pfl1R(pfA+0);
            ATL_pfl1R(pfA+8);
            pfA += lda;
            do /* M-loop */
            {
               rA0 = BetaAlpha;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[2];
               rC1_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[2];
               rC1_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[2];
               rC1_2 *= rA0;
               rC0_3 = *pC3;
               rC0_3 *= rA0;
               rC1_3 = pC3[2];
               rC1_3 *= rA0;
               rC0_4 = *pC4;
               rC0_4 *= rA0;
               rC1_4 = pC4[2];
               rC1_4 *= rA0;
               rC0_5 = *pC5;
               rC0_5 *= rA0;
               rC1_5 = pC5[2];
               rC1_5 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               m0 = rA0 * rB0;
               rA1 = pA0[2];
               m1 = rA1 * rB0;
               rB1 = pB0[2];
               m2 = rA0 * rB1;
               rB2 = pB0[4];
               m3 = rA1 * rB1;
               rB3 = pB0[6];
               m4 = rA0 * rB2;
               rB4 = pB0[8];
               m5 = rA1 * rB2;
               rB5 = pB0[10];

               for (k=Kloop; k; k -= 8) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
               } /* end K-loop */
               switch(kr)
               {
               case 1:
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  break;
               case 2:
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  break;
               case 3:
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  break;
               case 4:
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  break;
               case 5:
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  break;
               case 6:
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  break;
               case 7:
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pA0 += incAk;
                  pB0 += incBk;
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  break;
               case 0: ;
               }
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC0_1 += m2;
               m2 = rA0 * rB4;
               rC1_1 += m3;
               m3 = rA1 * rB4;
               rC0_2 += m4;
               m4 = rA0 * rB5;
               rC1_2 += m5;
               m5 = rA1 * rB5;
               pA0 += incAk0;
               pB0 += incBk0;
               rC0_3 += m0;
               rC1_3 += m1;
               rC0_4 += m2;
               rC1_4 += m3;
               rC0_5 += m4;
               rC1_5 += m5;
               rB0 = alpha;
               rC0_0 *= rB0;
               rC0_1 *= rB0;
               rC0_2 *= rB0;
               rC0_3 *= rB0;
               rC0_4 *= rB0;
               rC0_5 *= rB0;
               rC1_0 *= rB0;
               rC1_1 *= rB0;
               rC1_2 *= rB0;
               rC1_3 *= rB0;
               rC1_4 *= rB0;
               rC1_5 *= rB0;
               *pC0 = rC0_0;
               pC0[2] = rC1_0;
               *pC1 = rC0_1;
               pC1[2] = rC1_1;
               *pC2 = rC0_2;
               pC2[2] = rC1_2;
               *pC3 = rC0_3;
               pC3[2] = rC1_3;
               *pC4 = rC0_4;
               pC4[2] = rC1_4;
               *pC5 = rC0_5;
               pC5[2] = rC1_5;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pC3 += incCm;
               pC4 += incCm;
               pC5 += incCm;
               pA0 += incAm;
               pB0 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pC3 += incCn;
            pC4 += incCn;
            pC5 += incCn;
            pA0 += incAn;
            pB0 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_zJIK0x0x0NT2x1x8_aX_bX(M, k, K, alpha, ca, lda, cb + (((Nb) << 1)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
   if (Nb && (k=M-Mb))
      ATL_zJIK0x0x0NT1x6x8_aX_bX(k, Nb, K, alpha, ca + (((Mb) << 1)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
