#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x44TT1x1x4_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 8
   const int incAm = ((((lda) - 44) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(88*(ldb));
   #define incBn 2
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double m0, m1, m2, m3;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         pB0 += incBk0;
         rA0 = pA0[2];
         rB0 = *pB0;
         m1 = rA0 * rB0;
         pB0 += incBk0;
         rA0 = pA0[4];
         rB0 = *pB0;
         m2 = rA0 * rB0;
         pB0 += incBk0;
         rA0 = pA0[6];
         rB0 = *pB0;
         m3 = rA0 * rB0;
         pB0 += incBk0;
         rA0 = pA0[8];
         rB0 = *pB0;

         pA0 += (((incAk0) << 2));
         for (k=36; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m1;
            m1 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m2;
            m2 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m3;
            m3 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            pA0 += incAk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rC0_0 += m1;
         m1 = rA0 * rB0;
         pB0 += incBk;
         rA0 = pA0[4];
         rB0 = *pB0;
         rC0_0 += m2;
         m2 = rA0 * rB0;
         pB0 += incBk;
         rA0 = pA0[6];
         rB0 = *pB0;
         pA0 += (((incAk0) << 1)+incAk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m3;
         m3 = rA0 * rB0;
         pB0 += incBk0;
         rC0_0 += m0;
         rC0_0 += m1;
         rC0_0 += m2;
         rC0_0 += m3;
         pA0 += incAk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_zJIK0x0x44TT2x1x4_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>1)<<1;
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 8
   const int incAm = ((((((lda) << 1)) - 44) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(88*(ldb));
   #define incBn 2
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0;
   register double m0, m1, m2, m3, m4, m5, m6, m7;
   register double rC0_0, rC1_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         ATL_pfl1R(pfA+16);
         ATL_pfl1R(pfA+24);
         ATL_pfl1R(pfA+32);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            m0 = rA0 * rB0;
            rA1 = *pA1;
            m1 = rA1 * rB0;
            pB0 += incBk0;
            rA0 = pA0[2];
            rB0 = *pB0;
            rA1 = pA1[2];
            m2 = rA0 * rB0;
            m3 = rA1 * rB0;
            pB0 += incBk0;
            rA0 = pA0[4];
            rB0 = *pB0;
            rA1 = pA1[4];
            m4 = rA0 * rB0;
            m5 = rA1 * rB0;
            pB0 += incBk0;
            rA0 = pA0[6];
            rB0 = *pB0;
            rA1 = pA1[6];
            m6 = rA0 * rB0;
            m7 = rA1 * rB0;
            pB0 += incBk0;
            rA0 = pA0[8];
            rB0 = *pB0;
            rA1 = pA1[8];

            pA0 += (((incAk0) << 2));
            pA1 += (((incAk0) << 2));
            for (k=36; k; k -= 4) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m2;
               m2 = rA0 * rB0;
               rC1_0 += m3;
               m3 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m4;
               m4 = rA0 * rB0;
               rC1_0 += m5;
               m5 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m6;
               m6 = rA0 * rB0;
               rC1_0 += m7;
               m7 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               pA0 += incAk;
               pA1 += incAk;
            } /* end K-loop */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rA1 = pA1[2];
            rC0_0 += m2;
            m2 = rA0 * rB0;
            rC1_0 += m3;
            m3 = rA1 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rA1 = pA1[4];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rC1_0 += m5;
            m5 = rA1 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rA1 = pA1[6];
            pA0 += (((incAk0) << 1)+incAk0);
            pA1 += (((incAk0) << 1)+incAk0);
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m6;
            m6 = rA0 * rB0;
            rC1_0 += m7;
            m7 = rA1 * rB0;
            pB0 += incBk0;
            rC0_0 += m0;
            rC1_0 += m1;
            rC0_0 += m2;
            rC1_0 += m3;
            rC0_0 += m4;
            rC1_0 += m5;
            rC0_0 += m6;
            rC1_0 += m7;
            pA0 += incAk0;
            pA1 += incAk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x0x44TT1x1x4_aX_bX(k, N, 44, alpha, ca + (((Mb*lda) << 1)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x44TT1x6x4_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=6, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N/6)*6;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 8
   const int incAm = ((((lda) - 44) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(88*(ldb));
   #define incBn 12
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         ATL_pfl1R(pfA+16);
         ATL_pfl1R(pfA+24);
         ATL_pfl1R(pfA+32);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            m0 = rA0 * rB0;
            rB1 = pB0[2];
            m1 = rA0 * rB1;
            rB2 = pB0[4];
            m2 = rA0 * rB2;
            rB3 = pB0[6];
            m3 = rA0 * rB3;
            rB4 = pB0[8];
            m4 = rA0 * rB4;
            rB5 = pB0[10];
            m5 = rA0 * rB5;
            pB0 += incBk0;
            rA0 = pA0[2];
            rB0 = *pB0;
            rB1 = pB0[2];

            pA0 += (incAk0);
            for (k=40; k; k -= 4) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rB1 = pB0[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[4];
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rB3 = pB0[6];
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rB4 = pB0[8];
               rC0_3 += m3;
               m3 = rA0 * rB3;
               rB5 = pB0[10];
               rC0_4 += m4;
               m4 = rA0 * rB4;
               rC0_5 += m5;
               m5 = rA0 * rB5;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rB1 = pB0[2];
               pA0 += incAk;
            } /* end K-loop */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[4];
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rB3 = pB0[6];
            rC0_2 += m2;
            m2 = rA0 * rB2;
            rB4 = pB0[8];
            rC0_3 += m3;
            m3 = rA0 * rB3;
            rB5 = pB0[10];
            rC0_4 += m4;
            m4 = rA0 * rB4;
            rC0_5 += m5;
            m5 = rA0 * rB5;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rB1 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[4];
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rB3 = pB0[6];
            rC0_2 += m2;
            m2 = rA0 * rB2;
            rB4 = pB0[8];
            rC0_3 += m3;
            m3 = rA0 * rB3;
            rB5 = pB0[10];
            rC0_4 += m4;
            m4 = rA0 * rB4;
            rC0_5 += m5;
            m5 = rA0 * rB5;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rB1 = pB0[2];
            pA0 += (((incAk0) << 1));
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[4];
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rB3 = pB0[6];
            rC0_2 += m2;
            m2 = rA0 * rB2;
            rB4 = pB0[8];
            rC0_3 += m3;
            m3 = rA0 * rB3;
            rB5 = pB0[10];
            rC0_4 += m4;
            m4 = rA0 * rB4;
            rC0_5 += m5;
            m5 = rA0 * rB5;
            pB0 += incBk0;
            rC0_0 += m0;
            rC0_1 += m1;
            rC0_2 += m2;
            rC0_3 += m3;
            rC0_4 += m4;
            rC0_5 += m5;
            pA0 += incAk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            rC0_2 *= rB0;
            rC0_3 *= rB0;
            rC0_4 *= rB0;
            rC0_5 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            *pC5 = rC0_5;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_zJIK0x0x44TT1x1x4_aX_bX(M, k, 44, alpha, ca, lda, cb + (((Nb) << 1)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x0x44TT0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=6, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>1)<<1;
   const int Nb = (N/6)*6;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 8
   const int incAm = ((((((lda) << 1)) - 44) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(88*(ldb));
   #define incBn 12
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const double *pA0=A, *pA1=pA0+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            ATL_pfl1R(pfA+0);
            ATL_pfl1R(pfA+8);
            ATL_pfl1R(pfA+16);
            ATL_pfl1R(pfA+24);
            ATL_pfl1R(pfA+32);
            pfA += lda;
            do /* M-loop */
            {
               rA0 = BetaAlpha;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[2];
               rC1_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[2];
               rC1_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[2];
               rC1_2 *= rA0;
               rC0_3 = *pC3;
               rC0_3 *= rA0;
               rC1_3 = pC3[2];
               rC1_3 *= rA0;
               rC0_4 = *pC4;
               rC0_4 *= rA0;
               rC1_4 = pC4[2];
               rC1_4 *= rA0;
               rC0_5 = *pC5;
               rC0_5 *= rA0;
               rC1_5 = pC5[2];
               rC1_5 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               m0 = rA0 * rB0;
               rA1 = *pA1;
               m1 = rA1 * rB0;
               rB1 = pB0[2];
               m2 = rA0 * rB1;
               rB2 = pB0[4];
               m3 = rA1 * rB1;
               rB3 = pB0[6];
               m4 = rA0 * rB2;
               rB4 = pB0[8];
               m5 = rA1 * rB2;
               rB5 = pB0[10];

               for (k=40; k; k -= 4) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pB0 += incBk;
                  rA0 = pA0[2];
                  rB0 = *pB0;
                  rA1 = pA1[2];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pB0 += incBk;
                  rA0 = pA0[4];
                  rB0 = *pB0;
                  rA1 = pA1[4];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pB0 += incBk;
                  rA0 = pA0[6];
                  rB0 = *pB0;
                  rA1 = pA1[6];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  rC0_0 += m0;
                  m0 = rA0 * rB3;
                  rC1_0 += m1;
                  m1 = rA1 * rB3;
                  rC0_1 += m2;
                  m2 = rA0 * rB4;
                  rC1_1 += m3;
                  m3 = rA1 * rB4;
                  rC0_2 += m4;
                  m4 = rA0 * rB5;
                  rC1_2 += m5;
                  m5 = rA1 * rB5;
                  pB0 += incBk;
                  rA0 = pA0[8];
                  rB0 = *pB0;
                  rA1 = pA1[8];
                  rC0_3 += m0;
                  m0 = rA0 * rB0;
                  rB1 = pB0[2];
                  rC1_3 += m1;
                  m1 = rA1 * rB0;
                  rB2 = pB0[4];
                  rC0_4 += m2;
                  m2 = rA0 * rB1;
                  rB3 = pB0[6];
                  rC1_4 += m3;
                  m3 = rA1 * rB1;
                  rB4 = pB0[8];
                  rC0_5 += m4;
                  m4 = rA0 * rB2;
                  rB5 = pB0[10];
                  rC1_5 += m5;
                  m5 = rA1 * rB2;
                  pA0 += incAk;
                  pA1 += incAk;
               } /* end K-loop */
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC0_1 += m2;
               m2 = rA0 * rB4;
               rC1_1 += m3;
               m3 = rA1 * rB4;
               rC0_2 += m4;
               m4 = rA0 * rB5;
               rC1_2 += m5;
               m5 = rA1 * rB5;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB1 = pB0[2];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB2 = pB0[4];
               rC0_4 += m2;
               m2 = rA0 * rB1;
               rB3 = pB0[6];
               rC1_4 += m3;
               m3 = rA1 * rB1;
               rB4 = pB0[8];
               rC0_5 += m4;
               m4 = rA0 * rB2;
               rB5 = pB0[10];
               rC1_5 += m5;
               m5 = rA1 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC0_1 += m2;
               m2 = rA0 * rB4;
               rC1_1 += m3;
               m3 = rA1 * rB4;
               rC0_2 += m4;
               m4 = rA0 * rB5;
               rC1_2 += m5;
               m5 = rA1 * rB5;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB1 = pB0[2];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB2 = pB0[4];
               rC0_4 += m2;
               m2 = rA0 * rB1;
               rB3 = pB0[6];
               rC1_4 += m3;
               m3 = rA1 * rB1;
               rB4 = pB0[8];
               rC0_5 += m4;
               m4 = rA0 * rB2;
               rB5 = pB0[10];
               rC1_5 += m5;
               m5 = rA1 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC0_1 += m2;
               m2 = rA0 * rB4;
               rC1_1 += m3;
               m3 = rA1 * rB4;
               rC0_2 += m4;
               m4 = rA0 * rB5;
               rC1_2 += m5;
               m5 = rA1 * rB5;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB1 = pB0[2];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB2 = pB0[4];
               rC0_4 += m2;
               m2 = rA0 * rB1;
               rB3 = pB0[6];
               rC1_4 += m3;
               m3 = rA1 * rB1;
               rB4 = pB0[8];
               rC0_5 += m4;
               m4 = rA0 * rB2;
               rB5 = pB0[10];
               rC1_5 += m5;
               m5 = rA1 * rB2;
               pA0 += (((incAk0) << 1)+incAk0);
               pA1 += (((incAk0) << 1)+incAk0);
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC0_1 += m2;
               m2 = rA0 * rB4;
               rC1_1 += m3;
               m3 = rA1 * rB4;
               rC0_2 += m4;
               m4 = rA0 * rB5;
               rC1_2 += m5;
               m5 = rA1 * rB5;
               pB0 += incBk0;
               rC0_3 += m0;
               rC1_3 += m1;
               rC0_4 += m2;
               rC1_4 += m3;
               rC0_5 += m4;
               rC1_5 += m5;
               pA0 += incAk0;
               pA1 += incAk0;
               rB0 = alpha;
               rC0_0 *= rB0;
               rC0_1 *= rB0;
               rC0_2 *= rB0;
               rC0_3 *= rB0;
               rC0_4 *= rB0;
               rC0_5 *= rB0;
               rC1_0 *= rB0;
               rC1_1 *= rB0;
               rC1_2 *= rB0;
               rC1_3 *= rB0;
               rC1_4 *= rB0;
               rC1_5 *= rB0;
               *pC0 = rC0_0;
               pC0[2] = rC1_0;
               *pC1 = rC0_1;
               pC1[2] = rC1_1;
               *pC2 = rC0_2;
               pC2[2] = rC1_2;
               *pC3 = rC0_3;
               pC3[2] = rC1_3;
               *pC4 = rC0_4;
               pC4[2] = rC1_4;
               *pC5 = rC0_5;
               pC5[2] = rC1_5;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pC3 += incCm;
               pC4 += incCm;
               pC5 += incCm;
               pA0 += incAm;
               pA1 += incAm;
               pB0 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pC3 += incCn;
            pC4 += incCn;
            pC5 += incCn;
            pA0 += incAn;
            pA1 += incAn;
            pB0 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_zJIK0x0x44TT2x1x4_aX_bX(M, k, 44, alpha, ca, lda, cb + (((Nb) << 1)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
   if (Nb && (k=M-Mb))
      ATL_zJIK0x0x44TT1x6x4_aX_bX(k, Nb, 44, alpha, ca + (((Mb*lda) << 1)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
