#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK44x2x44NT2x2x44_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=44, NB=2, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=2, ku=44, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + 88;
   const double *stN = B + 4;
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 4 - (88*(lda)), incAn = -88;
   const int incBk = (((ldb) << 1)), incBm = -(88*(ldb));
   #define incBn 4
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 88;
   double *pC0=C, *pC1=pC0+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0, rB1;
   register double m0, m1, m2, m3, m4, m5, m6, m7;
   register double rC0_0, rC1_0, rC0_1, rC1_1;
   do /* M-loop */
   {
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      m0 = rA0 * rB0;
      rA1 = pA0[2];
      m1 = rA1 * rB0;
      rB1 = pB0[2];
      m2 = rA0 * rB1;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      m5 = rA1 * rB0;
      m6 = rA0 * rB1;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];

/*
 *    Completely unrolled K-loop
 */
      rC0_0 = m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 = m1;
      m1 = rA1 * rB0;
      rC0_1 = m2;
      m2 = rA0 * rB1;
      rC1_1 = m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = pB0[2];
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      pA0 += incAk;
      pB0 += incBk;
      rC0_0 += m0;
      rC1_0 += m1;
      rC0_1 += m2;
      rC1_1 += m3;
      rC0_0 += m4;
      rC1_0 += m5;
      rC0_1 += m6;
      rC1_1 += m7;
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC1_0 *= rB0;
      rC1_1 *= rB0;
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      pC0 += incCm;
      pC1 += incCm;
      pA0 += incAm;
      pB0 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK44x44x44NT0x0x0_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=44, NB=44, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=6, ku=44, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 88;
   const double *stN = B + 84;
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 4 - (88*(lda)), incAn = -88;
   const int incBk = (((ldb) << 1)), incBm = -(88*(ldb));
   #define incBn 12
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - 88;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double m0, m1, m2, m3, m4, m5, m6;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
         ATL_pfl1W(pC5);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = pA0[2];
         m1 = rA1 * rB0;
         rB1 = pB0[2];
         m2 = rA0 * rB1;
         rB2 = pB0[4];
         m3 = rA1 * rB1;
         rB3 = pB0[6];
         m4 = rA0 * rB2;
         rB4 = pB0[8];
         m5 = rA1 * rB2;
         rB5 = pB0[10];
         m6 = rA0 * rB3;

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA1 * rB3;
         rC1_0 = m1;
         m1 = rA0 * rB4;
         rC0_1 = m2;
         m2 = rA1 * rB4;
         rC1_1 = m3;
         m3 = rA0 * rB5;
         rC0_2 = m4;
         m4 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 = m5;
         m5 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 = m6;
         m6 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 = m0;
         m0 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 = m1;
         m1 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 = m2;
         m2 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 = m3;
         m3 = rA1 * rB2;
         rC1_5 = m4;
         m4 = rA0 * rB3;
         rC0_0 += m5;
         m5 = rA1 * rB3;
         rC1_0 += m6;
         m6 = rA0 * rB4;
         rC0_1 += m0;
         m0 = rA1 * rB4;
         rC1_1 += m1;
         m1 = rA0 * rB5;
         rC0_2 += m2;
         m2 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m3;
         m3 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m4;
         m4 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m5;
         m5 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m6;
         m6 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m0;
         m0 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m1;
         m1 = rA1 * rB2;
         rC1_5 += m2;
         m2 = rA0 * rB3;
         rC0_0 += m3;
         m3 = rA1 * rB3;
         rC1_0 += m4;
         m4 = rA0 * rB4;
         rC0_1 += m5;
         m5 = rA1 * rB4;
         rC1_1 += m6;
         m6 = rA0 * rB5;
         rC0_2 += m0;
         m0 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m1;
         m1 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m2;
         m2 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m3;
         m3 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m4;
         m4 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m5;
         m5 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m6;
         m6 = rA1 * rB2;
         rC1_5 += m0;
         m0 = rA0 * rB3;
         rC0_0 += m1;
         m1 = rA1 * rB3;
         rC1_0 += m2;
         m2 = rA0 * rB4;
         rC0_1 += m3;
         m3 = rA1 * rB4;
         rC1_1 += m4;
         m4 = rA0 * rB5;
         rC0_2 += m5;
         m5 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m6;
         m6 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m0;
         m0 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m1;
         m1 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m2;
         m2 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m3;
         m3 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m4;
         m4 = rA1 * rB2;
         rC1_5 += m5;
         m5 = rA0 * rB3;
         rC0_0 += m6;
         m6 = rA1 * rB3;
         rC1_0 += m0;
         m0 = rA0 * rB4;
         rC0_1 += m1;
         m1 = rA1 * rB4;
         rC1_1 += m2;
         m2 = rA0 * rB5;
         rC0_2 += m3;
         m3 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m4;
         m4 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m5;
         m5 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m6;
         m6 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m0;
         m0 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m1;
         m1 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m2;
         m2 = rA1 * rB2;
         rC1_5 += m3;
         m3 = rA0 * rB3;
         rC0_0 += m4;
         m4 = rA1 * rB3;
         rC1_0 += m5;
         m5 = rA0 * rB4;
         rC0_1 += m6;
         m6 = rA1 * rB4;
         rC1_1 += m0;
         m0 = rA0 * rB5;
         rC0_2 += m1;
         m1 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m2;
         m2 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m3;
         m3 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m4;
         m4 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m5;
         m5 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m6;
         m6 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m0;
         m0 = rA1 * rB2;
         rC1_5 += m1;
         m1 = rA0 * rB3;
         rC0_0 += m2;
         m2 = rA1 * rB3;
         rC1_0 += m3;
         m3 = rA0 * rB4;
         rC0_1 += m4;
         m4 = rA1 * rB4;
         rC1_1 += m5;
         m5 = rA0 * rB5;
         rC0_2 += m6;
         m6 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m0;
         m0 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m1;
         m1 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m2;
         m2 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m3;
         m3 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m4;
         m4 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m5;
         m5 = rA1 * rB2;
         rC1_5 += m6;
         m6 = rA0 * rB3;
         rC0_0 += m0;
         m0 = rA1 * rB3;
         rC1_0 += m1;
         m1 = rA0 * rB4;
         rC0_1 += m2;
         m2 = rA1 * rB4;
         rC1_1 += m3;
         m3 = rA0 * rB5;
         rC0_2 += m4;
         m4 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m5;
         m5 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m6;
         m6 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m0;
         m0 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m1;
         m1 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m2;
         m2 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m3;
         m3 = rA1 * rB2;
         rC1_5 += m4;
         m4 = rA0 * rB3;
         rC0_0 += m5;
         m5 = rA1 * rB3;
         rC1_0 += m6;
         m6 = rA0 * rB4;
         rC0_1 += m0;
         m0 = rA1 * rB4;
         rC1_1 += m1;
         m1 = rA0 * rB5;
         rC0_2 += m2;
         m2 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m3;
         m3 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m4;
         m4 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m5;
         m5 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m6;
         m6 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m0;
         m0 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m1;
         m1 = rA1 * rB2;
         rC1_5 += m2;
         m2 = rA0 * rB3;
         rC0_0 += m3;
         m3 = rA1 * rB3;
         rC1_0 += m4;
         m4 = rA0 * rB4;
         rC0_1 += m5;
         m5 = rA1 * rB4;
         rC1_1 += m6;
         m6 = rA0 * rB5;
         rC0_2 += m0;
         m0 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m1;
         m1 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m2;
         m2 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m3;
         m3 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m4;
         m4 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m5;
         m5 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m6;
         m6 = rA1 * rB2;
         rC1_5 += m0;
         m0 = rA0 * rB3;
         rC0_0 += m1;
         m1 = rA1 * rB3;
         rC1_0 += m2;
         m2 = rA0 * rB4;
         rC0_1 += m3;
         m3 = rA1 * rB4;
         rC1_1 += m4;
         m4 = rA0 * rB5;
         rC0_2 += m5;
         m5 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m6;
         m6 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m0;
         m0 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m1;
         m1 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m2;
         m2 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m3;
         m3 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m4;
         m4 = rA1 * rB2;
         rC1_5 += m5;
         m5 = rA0 * rB3;
         rC0_0 += m6;
         m6 = rA1 * rB3;
         rC1_0 += m0;
         m0 = rA0 * rB4;
         rC0_1 += m1;
         m1 = rA1 * rB4;
         rC1_1 += m2;
         m2 = rA0 * rB5;
         rC0_2 += m3;
         m3 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m4;
         m4 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m5;
         m5 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m6;
         m6 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m0;
         m0 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m1;
         m1 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m2;
         m2 = rA1 * rB2;
         rC1_5 += m3;
         m3 = rA0 * rB3;
         rC0_0 += m4;
         m4 = rA1 * rB3;
         rC1_0 += m5;
         m5 = rA0 * rB4;
         rC0_1 += m6;
         m6 = rA1 * rB4;
         rC1_1 += m0;
         m0 = rA0 * rB5;
         rC0_2 += m1;
         m1 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m2;
         m2 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m3;
         m3 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m4;
         m4 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m5;
         m5 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m6;
         m6 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m0;
         m0 = rA1 * rB2;
         rC1_5 += m1;
         m1 = rA0 * rB3;
         rC0_0 += m2;
         m2 = rA1 * rB3;
         rC1_0 += m3;
         m3 = rA0 * rB4;
         rC0_1 += m4;
         m4 = rA1 * rB4;
         rC1_1 += m5;
         m5 = rA0 * rB5;
         rC0_2 += m6;
         m6 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m0;
         m0 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m1;
         m1 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m2;
         m2 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m3;
         m3 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m4;
         m4 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m5;
         m5 = rA1 * rB2;
         rC1_5 += m6;
         m6 = rA0 * rB3;
         rC0_0 += m0;
         m0 = rA1 * rB3;
         rC1_0 += m1;
         m1 = rA0 * rB4;
         rC0_1 += m2;
         m2 = rA1 * rB4;
         rC1_1 += m3;
         m3 = rA0 * rB5;
         rC0_2 += m4;
         m4 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m5;
         m5 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m6;
         m6 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m0;
         m0 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m1;
         m1 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m2;
         m2 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m3;
         m3 = rA1 * rB2;
         rC1_5 += m4;
         m4 = rA0 * rB3;
         rC0_0 += m5;
         m5 = rA1 * rB3;
         rC1_0 += m6;
         m6 = rA0 * rB4;
         rC0_1 += m0;
         m0 = rA1 * rB4;
         rC1_1 += m1;
         m1 = rA0 * rB5;
         rC0_2 += m2;
         m2 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m3;
         m3 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m4;
         m4 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m5;
         m5 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m6;
         m6 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m0;
         m0 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m1;
         m1 = rA1 * rB2;
         rC1_5 += m2;
         m2 = rA0 * rB3;
         rC0_0 += m3;
         m3 = rA1 * rB3;
         rC1_0 += m4;
         m4 = rA0 * rB4;
         rC0_1 += m5;
         m5 = rA1 * rB4;
         rC1_1 += m6;
         m6 = rA0 * rB5;
         rC0_2 += m0;
         m0 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m1;
         m1 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m2;
         m2 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m3;
         m3 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m4;
         m4 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m5;
         m5 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m6;
         m6 = rA1 * rB2;
         rC1_5 += m0;
         m0 = rA0 * rB3;
         rC0_0 += m1;
         m1 = rA1 * rB3;
         rC1_0 += m2;
         m2 = rA0 * rB4;
         rC0_1 += m3;
         m3 = rA1 * rB4;
         rC1_1 += m4;
         m4 = rA0 * rB5;
         rC0_2 += m5;
         m5 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m6;
         m6 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m0;
         m0 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m1;
         m1 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m2;
         m2 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m3;
         m3 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m4;
         m4 = rA1 * rB2;
         rC1_5 += m5;
         m5 = rA0 * rB3;
         rC0_0 += m6;
         m6 = rA1 * rB3;
         rC1_0 += m0;
         m0 = rA0 * rB4;
         rC0_1 += m1;
         m1 = rA1 * rB4;
         rC1_1 += m2;
         m2 = rA0 * rB5;
         rC0_2 += m3;
         m3 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m4;
         m4 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m5;
         m5 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m6;
         m6 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m0;
         m0 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m1;
         m1 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m2;
         m2 = rA1 * rB2;
         rC1_5 += m3;
         m3 = rA0 * rB3;
         rC0_0 += m4;
         m4 = rA1 * rB3;
         rC1_0 += m5;
         m5 = rA0 * rB4;
         rC0_1 += m6;
         m6 = rA1 * rB4;
         rC1_1 += m0;
         m0 = rA0 * rB5;
         rC0_2 += m1;
         m1 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m2;
         m2 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m3;
         m3 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m4;
         m4 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m5;
         m5 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m6;
         m6 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m0;
         m0 = rA1 * rB2;
         rC1_5 += m1;
         m1 = rA0 * rB3;
         rC0_0 += m2;
         m2 = rA1 * rB3;
         rC1_0 += m3;
         m3 = rA0 * rB4;
         rC0_1 += m4;
         m4 = rA1 * rB4;
         rC1_1 += m5;
         m5 = rA0 * rB5;
         rC0_2 += m6;
         m6 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m0;
         m0 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m1;
         m1 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m2;
         m2 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m3;
         m3 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m4;
         m4 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m5;
         m5 = rA1 * rB2;
         rC1_5 += m6;
         m6 = rA0 * rB3;
         rC0_0 += m0;
         m0 = rA1 * rB3;
         rC1_0 += m1;
         m1 = rA0 * rB4;
         rC0_1 += m2;
         m2 = rA1 * rB4;
         rC1_1 += m3;
         m3 = rA0 * rB5;
         rC0_2 += m4;
         m4 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m5;
         m5 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m6;
         m6 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m0;
         m0 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m1;
         m1 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m2;
         m2 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m3;
         m3 = rA1 * rB2;
         rC1_5 += m4;
         m4 = rA0 * rB3;
         rC0_0 += m5;
         m5 = rA1 * rB3;
         rC1_0 += m6;
         m6 = rA0 * rB4;
         rC0_1 += m0;
         m0 = rA1 * rB4;
         rC1_1 += m1;
         m1 = rA0 * rB5;
         rC0_2 += m2;
         m2 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m3;
         m3 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m4;
         m4 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m5;
         m5 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m6;
         m6 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m0;
         m0 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m1;
         m1 = rA1 * rB2;
         rC1_5 += m2;
         m2 = rA0 * rB3;
         rC0_0 += m3;
         m3 = rA1 * rB3;
         rC1_0 += m4;
         m4 = rA0 * rB4;
         rC0_1 += m5;
         m5 = rA1 * rB4;
         rC1_1 += m6;
         m6 = rA0 * rB5;
         rC0_2 += m0;
         m0 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m1;
         m1 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m2;
         m2 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m3;
         m3 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m4;
         m4 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m5;
         m5 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m6;
         m6 = rA1 * rB2;
         rC1_5 += m0;
         m0 = rA0 * rB3;
         rC0_0 += m1;
         m1 = rA1 * rB3;
         rC1_0 += m2;
         m2 = rA0 * rB4;
         rC0_1 += m3;
         m3 = rA1 * rB4;
         rC1_1 += m4;
         m4 = rA0 * rB5;
         rC0_2 += m5;
         m5 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m6;
         m6 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m0;
         m0 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m1;
         m1 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m2;
         m2 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m3;
         m3 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m4;
         m4 = rA1 * rB2;
         rC1_5 += m5;
         m5 = rA0 * rB3;
         rC0_0 += m6;
         m6 = rA1 * rB3;
         rC1_0 += m0;
         m0 = rA0 * rB4;
         rC0_1 += m1;
         m1 = rA1 * rB4;
         rC1_1 += m2;
         m2 = rA0 * rB5;
         rC0_2 += m3;
         m3 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m4;
         m4 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m5;
         m5 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m6;
         m6 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m0;
         m0 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m1;
         m1 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m2;
         m2 = rA1 * rB2;
         rC1_5 += m3;
         m3 = rA0 * rB3;
         rC0_0 += m4;
         m4 = rA1 * rB3;
         rC1_0 += m5;
         m5 = rA0 * rB4;
         rC0_1 += m6;
         m6 = rA1 * rB4;
         rC1_1 += m0;
         m0 = rA0 * rB5;
         rC0_2 += m1;
         m1 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m2;
         m2 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m3;
         m3 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m4;
         m4 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m5;
         m5 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m6;
         m6 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m0;
         m0 = rA1 * rB2;
         rC1_5 += m1;
         m1 = rA0 * rB3;
         rC0_0 += m2;
         m2 = rA1 * rB3;
         rC1_0 += m3;
         m3 = rA0 * rB4;
         rC0_1 += m4;
         m4 = rA1 * rB4;
         rC1_1 += m5;
         m5 = rA0 * rB5;
         rC0_2 += m6;
         m6 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m0;
         m0 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m1;
         m1 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m2;
         m2 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m3;
         m3 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m4;
         m4 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m5;
         m5 = rA1 * rB2;
         rC1_5 += m6;
         m6 = rA0 * rB3;
         rC0_0 += m0;
         m0 = rA1 * rB3;
         rC1_0 += m1;
         m1 = rA0 * rB4;
         rC0_1 += m2;
         m2 = rA1 * rB4;
         rC1_1 += m3;
         m3 = rA0 * rB5;
         rC0_2 += m4;
         m4 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m5;
         m5 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m6;
         m6 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m0;
         m0 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m1;
         m1 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m2;
         m2 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m3;
         m3 = rA1 * rB2;
         rC1_5 += m4;
         m4 = rA0 * rB3;
         rC0_0 += m5;
         m5 = rA1 * rB3;
         rC1_0 += m6;
         m6 = rA0 * rB4;
         rC0_1 += m0;
         m0 = rA1 * rB4;
         rC1_1 += m1;
         m1 = rA0 * rB5;
         rC0_2 += m2;
         m2 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m3;
         m3 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m4;
         m4 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m5;
         m5 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m6;
         m6 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m0;
         m0 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m1;
         m1 = rA1 * rB2;
         rC1_5 += m2;
         m2 = rA0 * rB3;
         rC0_0 += m3;
         m3 = rA1 * rB3;
         rC1_0 += m4;
         m4 = rA0 * rB4;
         rC0_1 += m5;
         m5 = rA1 * rB4;
         rC1_1 += m6;
         m6 = rA0 * rB5;
         rC0_2 += m0;
         m0 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m1;
         m1 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m2;
         m2 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m3;
         m3 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m4;
         m4 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m5;
         m5 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m6;
         m6 = rA1 * rB2;
         rC1_5 += m0;
         m0 = rA0 * rB3;
         rC0_0 += m1;
         m1 = rA1 * rB3;
         rC1_0 += m2;
         m2 = rA0 * rB4;
         rC0_1 += m3;
         m3 = rA1 * rB4;
         rC1_1 += m4;
         m4 = rA0 * rB5;
         rC0_2 += m5;
         m5 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m6;
         m6 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m0;
         m0 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m1;
         m1 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m2;
         m2 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m3;
         m3 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m4;
         m4 = rA1 * rB2;
         rC1_5 += m5;
         m5 = rA0 * rB3;
         rC0_0 += m6;
         m6 = rA1 * rB3;
         rC1_0 += m0;
         m0 = rA0 * rB4;
         rC0_1 += m1;
         m1 = rA1 * rB4;
         rC1_1 += m2;
         m2 = rA0 * rB5;
         rC0_2 += m3;
         m3 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m4;
         m4 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m5;
         m5 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m6;
         m6 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m0;
         m0 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m1;
         m1 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m2;
         m2 = rA1 * rB2;
         rC1_5 += m3;
         m3 = rA0 * rB3;
         rC0_0 += m4;
         m4 = rA1 * rB3;
         rC1_0 += m5;
         m5 = rA0 * rB4;
         rC0_1 += m6;
         m6 = rA1 * rB4;
         rC1_1 += m0;
         m0 = rA0 * rB5;
         rC0_2 += m1;
         m1 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m2;
         m2 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m3;
         m3 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m4;
         m4 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m5;
         m5 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m6;
         m6 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m0;
         m0 = rA1 * rB2;
         rC1_5 += m1;
         m1 = rA0 * rB3;
         rC0_0 += m2;
         m2 = rA1 * rB3;
         rC1_0 += m3;
         m3 = rA0 * rB4;
         rC0_1 += m4;
         m4 = rA1 * rB4;
         rC1_1 += m5;
         m5 = rA0 * rB5;
         rC0_2 += m6;
         m6 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m0;
         m0 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m1;
         m1 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m2;
         m2 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m3;
         m3 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m4;
         m4 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m5;
         m5 = rA1 * rB2;
         rC1_5 += m6;
         m6 = rA0 * rB3;
         rC0_0 += m0;
         m0 = rA1 * rB3;
         rC1_0 += m1;
         m1 = rA0 * rB4;
         rC0_1 += m2;
         m2 = rA1 * rB4;
         rC1_1 += m3;
         m3 = rA0 * rB5;
         rC0_2 += m4;
         m4 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m5;
         m5 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m6;
         m6 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m0;
         m0 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m1;
         m1 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m2;
         m2 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m3;
         m3 = rA1 * rB2;
         rC1_5 += m4;
         m4 = rA0 * rB3;
         rC0_0 += m5;
         m5 = rA1 * rB3;
         rC1_0 += m6;
         m6 = rA0 * rB4;
         rC0_1 += m0;
         m0 = rA1 * rB4;
         rC1_1 += m1;
         m1 = rA0 * rB5;
         rC0_2 += m2;
         m2 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m3;
         m3 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m4;
         m4 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m5;
         m5 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m6;
         m6 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m0;
         m0 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m1;
         m1 = rA1 * rB2;
         rC1_5 += m2;
         m2 = rA0 * rB3;
         rC0_0 += m3;
         m3 = rA1 * rB3;
         rC1_0 += m4;
         m4 = rA0 * rB4;
         rC0_1 += m5;
         m5 = rA1 * rB4;
         rC1_1 += m6;
         m6 = rA0 * rB5;
         rC0_2 += m0;
         m0 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m1;
         m1 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m2;
         m2 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m3;
         m3 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m4;
         m4 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m5;
         m5 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m6;
         m6 = rA1 * rB2;
         rC1_5 += m0;
         m0 = rA0 * rB3;
         rC0_0 += m1;
         m1 = rA1 * rB3;
         rC1_0 += m2;
         m2 = rA0 * rB4;
         rC0_1 += m3;
         m3 = rA1 * rB4;
         rC1_1 += m4;
         m4 = rA0 * rB5;
         rC0_2 += m5;
         m5 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m6;
         m6 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m0;
         m0 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m1;
         m1 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m2;
         m2 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m3;
         m3 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m4;
         m4 = rA1 * rB2;
         rC1_5 += m5;
         m5 = rA0 * rB3;
         rC0_0 += m6;
         m6 = rA1 * rB3;
         rC1_0 += m0;
         m0 = rA0 * rB4;
         rC0_1 += m1;
         m1 = rA1 * rB4;
         rC1_1 += m2;
         m2 = rA0 * rB5;
         rC0_2 += m3;
         m3 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m4;
         m4 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m5;
         m5 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m6;
         m6 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m0;
         m0 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m1;
         m1 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m2;
         m2 = rA1 * rB2;
         rC1_5 += m3;
         m3 = rA0 * rB3;
         rC0_0 += m4;
         m4 = rA1 * rB3;
         rC1_0 += m5;
         m5 = rA0 * rB4;
         rC0_1 += m6;
         m6 = rA1 * rB4;
         rC1_1 += m0;
         m0 = rA0 * rB5;
         rC0_2 += m1;
         m1 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m2;
         m2 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m3;
         m3 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m4;
         m4 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m5;
         m5 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m6;
         m6 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m0;
         m0 = rA1 * rB2;
         rC1_5 += m1;
         m1 = rA0 * rB3;
         rC0_0 += m2;
         m2 = rA1 * rB3;
         rC1_0 += m3;
         m3 = rA0 * rB4;
         rC0_1 += m4;
         m4 = rA1 * rB4;
         rC1_1 += m5;
         m5 = rA0 * rB5;
         rC0_2 += m6;
         m6 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m0;
         m0 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m1;
         m1 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m2;
         m2 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m3;
         m3 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m4;
         m4 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m5;
         m5 = rA1 * rB2;
         rC1_5 += m6;
         m6 = rA0 * rB3;
         rC0_0 += m0;
         m0 = rA1 * rB3;
         rC1_0 += m1;
         m1 = rA0 * rB4;
         rC0_1 += m2;
         m2 = rA1 * rB4;
         rC1_1 += m3;
         m3 = rA0 * rB5;
         rC0_2 += m4;
         m4 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_2 += m5;
         m5 = rA0 * rB0;
         rB1 = pB0[2];
         rC0_3 += m6;
         m6 = rA1 * rB0;
         rB2 = pB0[4];
         rC1_3 += m0;
         m0 = rA0 * rB1;
         rB3 = pB0[6];
         rC0_4 += m1;
         m1 = rA1 * rB1;
         rB4 = pB0[8];
         rC1_4 += m2;
         m2 = rA0 * rB2;
         rB5 = pB0[10];
         rC0_5 += m3;
         m3 = rA1 * rB2;
         rC1_5 += m4;
         m4 = rA0 * rB3;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m5;
         m5 = rA1 * rB3;
         rC1_0 += m6;
         m6 = rA0 * rB4;
         rC0_1 += m0;
         m0 = rA1 * rB4;
         rC1_1 += m1;
         m1 = rA0 * rB5;
         rC0_2 += m2;
         m2 = rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         rC1_2 += m3;
         rC0_3 += m4;
         rC1_3 += m5;
         rC0_4 += m6;
         rC1_4 += m0;
         rC0_5 += m1;
         rC1_5 += m2;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC1_4 *= rB0;
         rC1_5 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         *pC3 = rC0_3;
         pC3[2] = rC1_3;
         *pC4 = rC0_4;
         pC4[2] = rC1_4;
         *pC5 = rC0_5;
         pC5[2] = rC1_5;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_zJIK44x2x44NT2x2x44_aX_b0(44, 2, 44, alpha, ca, lda, cb + 84, ldb, beta, cc + (84*(ldc)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
