#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK44x2x44TN2x2x4_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=44, NB=2, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=2, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + (88*(lda));
   const double *stN = B + (((ldb) << 2));
   const double *pfA = A + M;
   #define incAk 8
   const int incAm = ((((((lda) << 1)) - 44) << 1)), incAn = -(88*(lda));
   #define incBk 8
   const int incBm = -88, incBn = (((ldb) << 2));
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 88;
   double *pC0=C, *pC1=pC0+(((ldc) << 1));
   const double *pA0=A, *pA1=pA0+(((lda) << 1));
   const double *pB0=B, *pB1=pB0+(((ldb) << 1));
   register int k;
   register double rA0, rA1;
   register double rB0, rB1;
   register double m0, m1, m2, m3, m4, m5, m6, m7;
   register double rC0_0, rC1_0, rC0_1, rC1_1;
   do /* M-loop */
   {
      rC0_0 = rC1_0 = rC0_1 = rC1_1 = 0.0;
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      m0 = rA0 * rB0;
      rA1 = *pA1;
      m1 = rA1 * rB0;
      rB1 = *pB1;
      m2 = rA0 * rB1;
      m3 = rA1 * rB1;
      rA0 = pA0[2];
      rB0 = pB0[2];
      rA1 = pA1[2];
      m4 = rA0 * rB0;
      rB1 = pB1[2];
      m5 = rA1 * rB0;
      m6 = rA0 * rB1;
      m7 = rA1 * rB1;
      rA0 = pA0[4];
      rB0 = pB0[4];
      rA1 = pA1[4];

      pA0 += (((incAk0) << 1));
      pA1 += (((incAk0) << 1));
      pB0 += (((incBk0) << 1));
      pB1 += (((incBk0) << 1));
      for (k=40; k; k -= 4) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rB1 = *pB1;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA1[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rB1 = pB1[2];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA1[4];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rB1 = pB1[4];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA1[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rB1 = pB1[6];
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA1[8];
         pA0 += incAk;
         pA1 += incAk;
         pB0 += incBk;
         pB1 += incBk;
      } /* end K-loop */
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rB1 = *pB1;
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      rA0 = pA0[2];
      rB0 = pB0[2];
      rA1 = pA1[2];
      pA0 += (incAk0);
      pA1 += (incAk0);
      pB0 += (incBk0);
      pB1 += (incBk0);
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m4;
      m4 = rA0 * rB0;
      rB1 = *pB1;
      rC1_0 += m5;
      m5 = rA1 * rB0;
      rC0_1 += m6;
      m6 = rA0 * rB1;
      rC1_1 += m7;
      m7 = rA1 * rB1;
      rC0_0 += m0;
      rC1_0 += m1;
      rC0_1 += m2;
      rC1_1 += m3;
      rC0_0 += m4;
      rC1_0 += m5;
      rC0_1 += m6;
      rC1_1 += m7;
      pA0 += incAk0;
      pA1 += incAk0;
      pB0 += incBk0;
      pB1 += incBk0;
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      pC0 += incCm;
      pC1 += incCm;
      pA0 += incAm;
      pA1 += incAm;
      pB0 += incBm;
      pB1 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK44x44x44TN0x0x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=44, NB=44, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=6, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (88*(lda));
   const double *stN = B + (84*(ldb));
   const double *pfA = A + M;
   #define incAk 8
   const int incAm = ((((((lda) << 1)) - 44) << 1)), incAn = -(88*(lda));
   #define incBk 8
   const int incBm = -88, incBn = (((ldb) << 3)+((ldb) << 2));
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 4
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - 88;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const double *pA0=A, *pA1=pA0+(((lda) << 1));
   const double *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1)), *pB4=pB3+(((ldb) << 1)), *pB5=pB4+(((ldb) << 1));
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = rC1_0 = rC0_1 = rC1_1 = rC0_2 = rC1_2 = rC0_3 = rC1_3 = rC0_4 = rC1_4 = rC0_5 = rC1_5 = 0.0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = *pA1;
         m1 = rA1 * rB0;
         rB1 = *pB1;
         m2 = rA0 * rB1;
         rB2 = *pB2;
         m3 = rA1 * rB1;
         rB3 = *pB3;
         m4 = rA0 * rB2;
         rB4 = *pB4;
         m5 = rA1 * rB2;
         rB5 = *pB5;

         for (k=40; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC0_1 += m2;
            m2 = rA0 * rB4;
            rC1_1 += m3;
            m3 = rA1 * rB4;
            rC0_2 += m4;
            m4 = rA0 * rB5;
            rC1_2 += m5;
            m5 = rA1 * rB5;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA1[2];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB1 = pB1[2];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB2 = pB2[2];
            rC0_4 += m2;
            m2 = rA0 * rB1;
            rB3 = pB3[2];
            rC1_4 += m3;
            m3 = rA1 * rB1;
            rB4 = pB4[2];
            rC0_5 += m4;
            m4 = rA0 * rB2;
            rB5 = pB5[2];
            rC1_5 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC0_1 += m2;
            m2 = rA0 * rB4;
            rC1_1 += m3;
            m3 = rA1 * rB4;
            rC0_2 += m4;
            m4 = rA0 * rB5;
            rC1_2 += m5;
            m5 = rA1 * rB5;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA1[4];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB1 = pB1[4];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB2 = pB2[4];
            rC0_4 += m2;
            m2 = rA0 * rB1;
            rB3 = pB3[4];
            rC1_4 += m3;
            m3 = rA1 * rB1;
            rB4 = pB4[4];
            rC0_5 += m4;
            m4 = rA0 * rB2;
            rB5 = pB5[4];
            rC1_5 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC0_1 += m2;
            m2 = rA0 * rB4;
            rC1_1 += m3;
            m3 = rA1 * rB4;
            rC0_2 += m4;
            m4 = rA0 * rB5;
            rC1_2 += m5;
            m5 = rA1 * rB5;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA1[6];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB1 = pB1[6];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB2 = pB2[6];
            rC0_4 += m2;
            m2 = rA0 * rB1;
            rB3 = pB3[6];
            rC1_4 += m3;
            m3 = rA1 * rB1;
            rB4 = pB4[6];
            rC0_5 += m4;
            m4 = rA0 * rB2;
            rB5 = pB5[6];
            rC1_5 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC0_1 += m2;
            m2 = rA0 * rB4;
            rC1_1 += m3;
            m3 = rA1 * rB4;
            rC0_2 += m4;
            m4 = rA0 * rB5;
            rC1_2 += m5;
            m5 = rA1 * rB5;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA1[8];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB1 = pB1[8];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB2 = pB2[8];
            rC0_4 += m2;
            m2 = rA0 * rB1;
            rB3 = pB3[8];
            rC1_4 += m3;
            m3 = rA1 * rB1;
            rB4 = pB4[8];
            rC0_5 += m4;
            m4 = rA0 * rB2;
            rB5 = pB5[8];
            rC1_5 += m5;
            m5 = rA1 * rB2;
            pA0 += incAk;
            pA1 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
            pB4 += incBk;
            pB5 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB3;
         rC1_0 += m1;
         m1 = rA1 * rB3;
         rC0_1 += m2;
         m2 = rA0 * rB4;
         rC1_1 += m3;
         m3 = rA1 * rB4;
         rC0_2 += m4;
         m4 = rA0 * rB5;
         rC1_2 += m5;
         m5 = rA1 * rB5;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA1[2];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rB1 = pB1[2];
         rC1_3 += m1;
         m1 = rA1 * rB0;
         rB2 = pB2[2];
         rC0_4 += m2;
         m2 = rA0 * rB1;
         rB3 = pB3[2];
         rC1_4 += m3;
         m3 = rA1 * rB1;
         rB4 = pB4[2];
         rC0_5 += m4;
         m4 = rA0 * rB2;
         rB5 = pB5[2];
         rC1_5 += m5;
         m5 = rA1 * rB2;
         rC0_0 += m0;
         m0 = rA0 * rB3;
         rC1_0 += m1;
         m1 = rA1 * rB3;
         rC0_1 += m2;
         m2 = rA0 * rB4;
         rC1_1 += m3;
         m3 = rA1 * rB4;
         rC0_2 += m4;
         m4 = rA0 * rB5;
         rC1_2 += m5;
         m5 = rA1 * rB5;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA1[4];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rB1 = pB1[4];
         rC1_3 += m1;
         m1 = rA1 * rB0;
         rB2 = pB2[4];
         rC0_4 += m2;
         m2 = rA0 * rB1;
         rB3 = pB3[4];
         rC1_4 += m3;
         m3 = rA1 * rB1;
         rB4 = pB4[4];
         rC0_5 += m4;
         m4 = rA0 * rB2;
         rB5 = pB5[4];
         rC1_5 += m5;
         m5 = rA1 * rB2;
         rC0_0 += m0;
         m0 = rA0 * rB3;
         rC1_0 += m1;
         m1 = rA1 * rB3;
         rC0_1 += m2;
         m2 = rA0 * rB4;
         rC1_1 += m3;
         m3 = rA1 * rB4;
         rC0_2 += m4;
         m4 = rA0 * rB5;
         rC1_2 += m5;
         m5 = rA1 * rB5;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA1[6];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rB1 = pB1[6];
         rC1_3 += m1;
         m1 = rA1 * rB0;
         rB2 = pB2[6];
         rC0_4 += m2;
         m2 = rA0 * rB1;
         rB3 = pB3[6];
         rC1_4 += m3;
         m3 = rA1 * rB1;
         rB4 = pB4[6];
         rC0_5 += m4;
         m4 = rA0 * rB2;
         rB5 = pB5[6];
         rC1_5 += m5;
         m5 = rA1 * rB2;
         pA0 += (((incAk0) << 1)+incAk0);
         pA1 += (((incAk0) << 1)+incAk0);
         pB0 += (((incBk0) << 1)+incBk0);
         pB1 += (((incBk0) << 1)+incBk0);
         pB2 += (((incBk0) << 1)+incBk0);
         pB3 += (((incBk0) << 1)+incBk0);
         pB4 += (((incBk0) << 1)+incBk0);
         pB5 += (((incBk0) << 1)+incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB3;
         rC1_0 += m1;
         m1 = rA1 * rB3;
         rC0_1 += m2;
         m2 = rA0 * rB4;
         rC1_1 += m3;
         m3 = rA1 * rB4;
         rC0_2 += m4;
         m4 = rA0 * rB5;
         rC1_2 += m5;
         m5 = rA1 * rB5;
         rC0_3 += m0;
         rC1_3 += m1;
         rC0_4 += m2;
         rC1_4 += m3;
         rC0_5 += m4;
         rC1_5 += m5;
         pA0 += incAk0;
         pA1 += incAk0;
         pB0 += incBk0;
         pB1 += incBk0;
         pB2 += incBk0;
         pB3 += incBk0;
         pB4 += incBk0;
         pB5 += incBk0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         *pC3 = rC0_3;
         pC3[2] = rC1_3;
         *pC4 = rC0_4;
         pC4[2] = rC1_4;
         *pC5 = rC0_5;
         pC5[2] = rC1_5;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
         pB5 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
   }
   while(pB0 != stN);
   ATL_zJIK44x2x44TN2x2x4_a1_b0(44, 2, 44, alpha, ca, lda, cb + (84*(ldb)), ldb, beta, cc + (84*(ldc)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
